/*
 * Copyright 2009-2010 Nanjing RedOrange ltd (http://www.red-orange.cn)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package redora.client.validation;

import com.google.gwt.core.client.GWT;
import com.google.gwt.json.client.JSONArray;
import redora.client.constants.RedoraMessages;

/**
 * 
 * @author Nanjing RedOrange (www.red-orange.cn)
 */
public abstract class DefaultMessageAllocator {

    static RedoraMessages redoraMessage = GWT.create(RedoraMessages.class);

    public abstract String rule(String objectName, int ruleId, JSONArray arguments);
    public abstract String message(String objectName, int messageId, JSONArray arguments);

    protected String defaultRule(int messageId, JSONArray arguments) {
            switch (messageId) {
                case -1:
                    return redoraMessage.businessRule_1();
                case -2:
                    return redoraMessage.businessRule_2(arguments.get(0).isObject().get("argument").toString());
                case -3:
                    return redoraMessage.businessRule_3();
                case -4:
                    return redoraMessage.businessRule_4(
                            arguments.get(0).isObject().get("argument").isString().stringValue());
                default:
                    return null;
            }
    }
}
